ViennaCL - The Vienna Computing Library: viennacl::ocl::kernel Class Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Friends | List of all members
viennacl::ocl::kernel Class Reference

Represents an OpenCL kernel within ViennaCL. More...

`#include <kernel.hpp>`

## Public Types
typedef vcl_size_t | size_type

## Public Member Functions
| kernel ()
| kernel (cl_kernel kernel_handle, viennacl::ocl::program const &kernel_program, viennacl::ocl::context const &kernel_context, std::string const &name)
| kernel (kernel const &other)
viennacl::ocl::kernel & | operator= (const kernel &other)
void | arg (unsigned int pos, cl_char val)
| Sets a char argument at the provided position. More...
void | arg (unsigned int pos, cl_uchar val)
| Sets a char argument at the provided position. More...
void | arg (unsigned int pos, cl_short val)
| Sets a argument of type short at the provided position. More...
void | arg (unsigned int pos, cl_ushort val)
| Sets a argument of type unsigned short at the provided position. More...
void | arg (unsigned int pos, cl_uint val)
| Sets an unsigned integer argument at the provided position. More...
void | arg (unsigned int pos, packed_cl_uint val)
| Sets four packed unsigned integers as argument at the provided position. More...
void | arg (unsigned int pos, float val)
| Sets a single precision floating point argument at the provided position. More...
void | arg (unsigned int pos, double val)
| Sets a double precision floating point argument at the provided position. More...
void | arg (unsigned int pos, cl_int val)
| Sets an int argument at the provided position. More...
void | arg (unsigned int pos, cl_ulong val)
| Sets an unsigned long argument at the provided position. More...
void | arg (unsigned int pos, cl_long val)
| Sets an unsigned long argument at the provided position. More...
template<class VCL_TYPE >
void | arg (unsigned int pos, VCL_TYPE const &val)
| Sets an OpenCL memory object at the provided position. More...
template<class CL_TYPE >
void | arg (unsigned int pos, viennacl::ocl::handle< CL_TYPE > const &h)
| Sets an OpenCL object at the provided position. More...
void | arg (unsigned int pos, const local_mem &mem)
| Sets an OpenCL local memory object at the provided position. More...
template<typename T0 >
kernel & | operator() (T0 const &t0)
| Convenience function for setting one kernel parameter. More...
template<typename T0 , typename T1 >
kernel & | operator() (T0 const &t0, T1 const &t1)
| Convenience function for setting two kernel parameters. More...
template<typename T0 , typename T1 , typename T2 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2)
| Convenience function for setting three kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3)
| Convenience function for setting four kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4)
| Convenience function for setting five kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5)
| Convenience function for setting six kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6)
| Convenience function for setting seven kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7)
| Convenience function for setting eight kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8)
| Convenience function for setting nine kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9)
| Convenience function for setting ten kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10)
| Convenience function for setting eleven kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11)
| Convenience function for setting twelve kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12)
| Convenience function for setting thirteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13)
| Convenience function for setting fourteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14)
| Convenience function for setting fifteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15)
| Convenience function for setting sixteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16)
| Convenience function for setting seventeen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17)
| Convenience function for setting eighteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18)
| Convenience function for setting nineteen kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19)
| Convenience function for setting twenty kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20)
| Convenience function for setting twentyone kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21)
| Convenience function for setting twentytwo kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22)
| Convenience function for setting 23 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23)
| Convenience function for setting 24 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24)
| Convenience function for setting 25 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25)
| Convenience function for setting 26 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26)
| Convenience function for setting 27 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26, T27 const &t27)
| Convenience function for setting 28 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26, T27 const &t27, T28 const &t28)
| Convenience function for setting 29 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26, T27 const &t27, T28 const &t28, T29 const &t29)
| Convenience function for setting 30 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 , typename T30 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26, T27 const &t27, T28 const &t28, T29 const &t29, T30 const &t30)
| Convenience function for setting 31 kernel parameters. More...
template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 , typename T30 , typename T31 >
kernel & | operator() (T0 const &t0, T1 const &t1, T2 const &t2, T3 const &t3, T4 const &t4, T5 const &t5, T6 const &t6, T7 const &t7, T8 const &t8, T9 const &t9, T10 const &t10, T11 const &t11, T12 const &t12, T13 const &t13, T14 const &t14, T15 const &t15, T16 const &t16, T17 const &t17, T18 const &t18, T19 const &t19, T20 const &t20, T21 const &t21, T22 const &t22, T23 const &t23, T24 const &t24, T25 const &t25, T26 const &t26, T27 const &t27, T28 const &t28, T29 const &t29, T30 const &t30, T31 const &t31)
| Convenience function for setting 32 kernel parameters. More...
size_type | local_work_size (int index=0) const
| Returns the local work size at the respective dimension. More...
size_type | global_work_size (int index=0) const
| Returns the global work size at the respective dimension. More...
void | local_work_size (int index, size_type s)
| Sets the local work size at the respective dimension. More...
void | global_work_size (int index, size_type s)
| Sets the global work size at the respective dimension. More...
std::string const & | name () const
viennacl::ocl::handle < cl_kernel > const & | handle () const
viennacl::ocl::context const & | context () const

## Friends
template<typename KernelType >
void | enqueue (KernelType &k, viennacl::ocl::command_queue const &queue)
| Enqueues a kernel in the provided queue. More...

## Detailed Description

Represents an OpenCL kernel within ViennaCL.

Examples:
  custom-context.cpp, custom-kernels.cpp, and matrix-free.cpp.

Definition at line 58 of file kernel.hpp.

## Member Typedef Documentation

typedef vcl_size_t viennacl::ocl::kernel::size_type

Definition at line 64 of file kernel.hpp.

## Constructor & Destructor Documentation

viennacl::ocl::kernel::kernel | ( |  | ) |
| inline

Definition at line 66 of file kernel.hpp.

viennacl::ocl::kernel::kernel | ( | cl_kernel | kernel_handle,
|  | viennacl::ocl::program const & | kernel_program,
|  | viennacl::ocl::context const & | kernel_context,
|  | std::string const & | name
| ) |  |
| inline

Definition at line 73 of file kernel.hpp.

viennacl::ocl::kernel::kernel | ( | kernel const & | other | ) |
| inline

Definition at line 82 of file kernel.hpp.

## Member Function Documentation

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_char | val
| ) |  |
| inline

Sets a char argument at the provided position.

Definition at line 116 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_uchar | val
| ) |  |
| inline

Sets a char argument at the provided position.

Definition at line 126 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_short | val
| ) |  |
| inline

Sets a argument of type short at the provided position.

Definition at line 136 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_ushort | val
| ) |  |
| inline

Sets a argument of type unsigned short at the provided position.

Definition at line 146 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_uint | val
| ) |  |
| inline

Sets an unsigned integer argument at the provided position.

Definition at line 157 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | packed_cl_uint | val
| ) |  |
| inline

Sets four packed unsigned integers as argument at the provided position.

Definition at line 167 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | float | val
| ) |  |
| inline

Sets a single precision floating point argument at the provided position.

Definition at line 177 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | double | val
| ) |  |
| inline

Sets a double precision floating point argument at the provided position.

Definition at line 187 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_int | val
| ) |  |
| inline

Sets an int argument at the provided position.

Definition at line 197 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_ulong | val
| ) |  |
| inline

Sets an unsigned long argument at the provided position.

Definition at line 207 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | cl_long | val
| ) |  |
| inline

Sets an unsigned long argument at the provided position.

Definition at line 217 of file kernel.hpp.

template<class VCL_TYPE >

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | VCL_TYPE const & | val
| ) |  |
| inline

Sets an OpenCL memory object at the provided position.

Definition at line 229 of file kernel.hpp.

template<class CL_TYPE >

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | viennacl::ocl::handle< CL_TYPE > const & | h
| ) |  |
| inline

Sets an OpenCL object at the provided position.

Definition at line 244 of file kernel.hpp.

void viennacl::ocl::kernel::arg | ( | unsigned int | pos,
|  | const local_mem & | mem
| ) |  |
| inline

Sets an OpenCL local memory object at the provided position.

Definition at line 257 of file kernel.hpp.

viennacl::ocl::context const& viennacl::ocl::kernel::context | ( |  | ) | const
| inline

Definition at line 788 of file kernel.hpp.

size_type viennacl::ocl::kernel::global_work_size | ( | int | index = `0` | ) | const
| inline

Returns the global work size at the respective dimension.

Parameters

  index | Dimension index (currently either 0 or 1)

Definition at line 751 of file kernel.hpp.

void viennacl::ocl::kernel::global_work_size | ( | int | index,
|  | size_type | s
| ) |  |
| inline

Sets the global work size at the respective dimension.

Parameters

  index | Dimension index (currently either 0 or 1)
  s | The new global work size

Definition at line 775 of file kernel.hpp.

viennacl::ocl::handle<cl_kernel> const& viennacl::ocl::kernel::handle | ( |  | ) | const
| inline

Definition at line 786 of file kernel.hpp.

size_type viennacl::ocl::kernel::local_work_size | ( | int | index = `0` | ) | const
| inline

Returns the local work size at the respective dimension.

Parameters

  index | Dimension index (currently either 0 or 1)

Definition at line 742 of file kernel.hpp.

void viennacl::ocl::kernel::local_work_size | ( | int | index,
|  | size_type | s
| ) |  |
| inline

Sets the local work size at the respective dimension.

Parameters

  index | Dimension index (currently either 0 or 1)
  s | The new local work size

Definition at line 762 of file kernel.hpp.

std::string const& viennacl::ocl::kernel::name | ( |  | ) | const
| inline

Definition at line 784 of file kernel.hpp.

template<typename T0 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0 | ) |
| inline

Convenience function for setting one kernel parameter.

Definition at line 271 of file kernel.hpp.

template<typename T0 , typename T1 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1
| ) |  |
| inline

Convenience function for setting two kernel parameters.

Definition at line 279 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2
| ) |  |
| inline

Convenience function for setting three kernel parameters.

Definition at line 287 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3
| ) |  |
| inline

Convenience function for setting four kernel parameters.

Definition at line 295 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4
| ) |  |
| inline

Convenience function for setting five kernel parameters.

Definition at line 303 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5
| ) |  |
| inline

Convenience function for setting six kernel parameters.

Definition at line 311 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6
| ) |  |
| inline

Convenience function for setting seven kernel parameters.

Definition at line 319 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7
| ) |  |
| inline

Convenience function for setting eight kernel parameters.

Definition at line 327 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8
| ) |  |
| inline

Convenience function for setting nine kernel parameters.

Definition at line 335 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9
| ) |  |
| inline

Convenience function for setting ten kernel parameters.

Definition at line 344 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10
| ) |  |
| inline

Convenience function for setting eleven kernel parameters.

Definition at line 354 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11
| ) |  |
| inline

Convenience function for setting twelve kernel parameters.

Definition at line 364 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12
| ) |  |
| inline

Convenience function for setting thirteen kernel parameters.

Definition at line 375 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13
| ) |  |
| inline

Convenience function for setting fourteen kernel parameters.

Definition at line 387 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14
| ) |  |
| inline

Convenience function for setting fifteen kernel parameters.

Definition at line 401 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15
| ) |  |
| inline

Convenience function for setting sixteen kernel parameters.

Definition at line 415 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16
| ) |  |
| inline

Convenience function for setting seventeen kernel parameters.

Definition at line 429 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17
| ) |  |
| inline

Convenience function for setting eighteen kernel parameters.

Definition at line 443 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18
| ) |  |
| inline

Convenience function for setting nineteen kernel parameters.

Definition at line 458 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19
| ) |  |
| inline

Convenience function for setting twenty kernel parameters.

Definition at line 476 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20
| ) |  |
| inline

Convenience function for setting twentyone kernel parameters.

Definition at line 494 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21
| ) |  |
| inline

Convenience function for setting twentytwo kernel parameters.

Definition at line 512 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22
| ) |  |
| inline

Convenience function for setting 23 kernel parameters.

Definition at line 530 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23
| ) |  |
| inline

Convenience function for setting 24 kernel parameters.

Definition at line 548 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24
| ) |  |
| inline

Convenience function for setting 25 kernel parameters.

Definition at line 567 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25
| ) |  |
| inline

Convenience function for setting 26 kernel parameters.

Definition at line 588 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26
| ) |  |
| inline

Convenience function for setting 27 kernel parameters.

Definition at line 609 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26,
|  | T27 const & | t27
| ) |  |
| inline

Convenience function for setting 28 kernel parameters.

Definition at line 630 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26,
|  | T27 const & | t27,
|  | T28 const & | t28
| ) |  |
| inline

Convenience function for setting 29 kernel parameters.

Definition at line 651 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26,
|  | T27 const & | t27,
|  | T28 const & | t28,
|  | T29 const & | t29
| ) |  |
| inline

Convenience function for setting 30 kernel parameters.

Definition at line 672 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 , typename T30 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26,
|  | T27 const & | t27,
|  | T28 const & | t28,
|  | T29 const & | t29,
|  | T30 const & | t30
| ) |  |
| inline

Convenience function for setting 31 kernel parameters.

Definition at line 694 of file kernel.hpp.

template<typename T0 , typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 , typename T7 , typename T8 , typename T9 , typename T10 , typename T11 , typename T12 , typename T13 , typename T14 , typename T15 , typename T16 , typename T17 , typename T18 , typename T19 , typename T20 , typename T21 , typename T22 , typename T23 , typename T24 , typename T25 , typename T26 , typename T27 , typename T28 , typename T29 , typename T30 , typename T31 >

kernel& viennacl::ocl::kernel::operator() | ( | T0 const & | t0,
|  | T1 const & | t1,
|  | T2 const & | t2,
|  | T3 const & | t3,
|  | T4 const & | t4,
|  | T5 const & | t5,
|  | T6 const & | t6,
|  | T7 const & | t7,
|  | T8 const & | t8,
|  | T9 const & | t9,
|  | T10 const & | t10,
|  | T11 const & | t11,
|  | T12 const & | t12,
|  | T13 const & | t13,
|  | T14 const & | t14,
|  | T15 const & | t15,
|  | T16 const & | t16,
|  | T17 const & | t17,
|  | T18 const & | t18,
|  | T19 const & | t19,
|  | T20 const & | t20,
|  | T21 const & | t21,
|  | T22 const & | t22,
|  | T23 const & | t23,
|  | T24 const & | t24,
|  | T25 const & | t25,
|  | T26 const & | t26,
|  | T27 const & | t27,
|  | T28 const & | t28,
|  | T29 const & | t29,
|  | T30 const & | t30,
|  | T31 const & | t31
| ) |  |
| inline

Convenience function for setting 32 kernel parameters.

Definition at line 718 of file kernel.hpp.

viennacl::ocl::kernel& viennacl::ocl::kernel::operator= | ( | const kernel & | other | ) |
| inline

Definition at line 97 of file kernel.hpp.

## Friends And Related Function Documentation

template<typename KernelType >

void enqueue | ( | KernelType & | k,
|  | viennacl::ocl::command_queue const & | queue
| ) |  |
| friend

Enqueues a kernel in the provided queue.

Definition at line 50 of file enqueue.hpp.

The documentation for this class was generated from the following files:

- viennacl/ocl/kernel.hpp
- viennacl/ocl/context.hpp